'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = loader;

var _loaderUtils = require('loader-utils');

function loader(source) {
  // module.exports = function(source) {
  var options = (0, _loaderUtils.getOptions)(this);

  var data = void 0;
  var output = '';
  var module = void 0;
  var moduleName = options.moduleName || 'app.constants';
  var configKey = options.configKey;

  var createModule = options.createModule !== false;

  try {
    data = JSON.parse(source);
  } catch (e) {
    throw new Error(`${this.resourcePath} must be a valid json object`);
  }

  // reduce data down to requested key
  var parts = configKey.split('.');
  for (var i = 0, l = parts.length; i < l; ++i) {
    if (data[parts[i]]) {
      data = data[parts[i]];
    } else {
      data = null;
      break;
    }
  }

  if (data) {
    module = `angular.module("${moduleName}"${createModule ? ', []' : ''})`;
    Object.keys(data).forEach(function (key) {
      module += `\n  .constant("${key}", ${JSON.stringify(data[key], null, 0)})`;
    });
    module += ';\n';

    if (options.wrap) {
      if (typeof options.wrap === 'string' && options.wrap.toUpperCase() === 'ES6') {
        output = `import angular from "angular";\nexport default ${module}`;
      } else {
        output = `(function () { \n return ${module}\n})();\n`;
      }
    } else {
      output = module;
    }
  }
  return output;
}